/*
 * Created on Jan 24, 2005
 */
package proxyconfig;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.util.ListIterator;

/**
 * @author danjo
 */
public class AdvancedOptionsPanel extends JPanel implements ActionListener {

    ProxyConfig proxyConfig;
    
    JTextField fakeStartTF, fakeMaskTF;

    JTextField stdDNSPortTF, legacyDNSPortTF;
    
    JTextField winTunNameTF;
    
    AdvancedOptionsPanel (ProxyConfig proxyConfig) {
        
            this.proxyConfig = proxyConfig;
            
            proxyConfig.changeListener.setEnabled(false);
            
            setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
            setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
            
            add(new MessageLabel(
                    "Advanced Options", 
                    ProxyConfig.HEADING_COLOR, 	//background color
                    24 //font size
                    ));
            

            add(Box.createRigidArea(new Dimension(40,40)));
            
            
            JEditorPane introLB = new JEditorPane(
                    "text/html",
                    "<font face=\"arial\">Here you can configure the advanced parameters of the proxy. " +
                    "In most cases, you can leave this section untouched."
                    );
            introLB.setMaximumSize(new Dimension(500,40));
            introLB.setBackground (ProxyConfig.BACKGROUND_COLOR);
            
            JPanel tempPanel = new JPanel();
            tempPanel.setLayout(new BoxLayout(tempPanel, BoxLayout.X_AXIS));
            add(tempPanel);
            tempPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
            tempPanel.add(introLB);
            tempPanel.add(Box.createHorizontalGlue());

            add(Box.createVerticalGlue());
            


    		JLabel tempLabel;

    		// The preferred Dimension of all the input fields - mainly used to enforce a common height
    		Dimension minDim = new Dimension(100, 25);

    		
    		JEditorPane fakeLB = new JEditorPane (
    		        "text/html",
    		        "<font face=\"arial\" color=\"blue\"><h2>Fake IP Addresses"
    		        );
    		fakeLB.setMaximumSize(new Dimension(500,60));
    		fakeLB.setBackground (ProxyConfig.BACKGROUND_COLOR);
    		tempPanel = new JPanel();
            tempPanel.setLayout(new BoxLayout(tempPanel, BoxLayout.X_AXIS));
            add(tempPanel);
            tempPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
            tempPanel.add(fakeLB);
            
            HelpButton helpFakeBT = new HelpButton("HELP_FAKE_ADDR", this);
            
            tempPanel.add(Box.createRigidArea(new Dimension(5,5)));
            tempPanel.add(helpFakeBT);
            
            
            tempPanel.add(Box.createHorizontalGlue());
            
    		
            JPanel fakePanel = new JPanel();
            fakePanel.setMaximumSize(new Dimension(500,100));
            fakePanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
            add(fakePanel);
            
            Insets insets = new Insets(2,2,2,2);
    		GridBagLayout gbag = new GridBagLayout();
    		fakePanel.setLayout(gbag);

    		GridBagConstraints gc = new GridBagConstraints();
    		gc.weighty = 0.0;
    		gc.fill = GridBagConstraints.HORIZONTAL;
    		gc.insets = insets;
    		gc.gridx = GridBagConstraints.REMAINDER;
    		gc.anchor = GridBagConstraints.WEST;

    		
    		tempLabel = new JLabel("Fake Address Range Start");
    		gc.gridx = 0;
    		gc.gridy = 0;
    		gc.weightx = 0.0;
    		gbag.setConstraints(tempLabel, gc);
    		fakePanel.add(tempLabel);

    		fakeStartTF = new JTextField(25);
    		fakeStartTF.setMinimumSize(minDim);
    		fakeStartTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
    		fakeStartTF.getDocument().addDocumentListener(proxyConfig.changeListener);
    		gc.gridx = 1;
    		gc.gridy = 0;
    		gc.weightx = 1.0;
    		gbag.setConstraints(fakeStartTF, gc);
    		fakePanel.add(fakeStartTF);

    		
    		tempLabel = new JLabel("Fake Address Range Mask");
    		gc.gridx = 0;
    		gc.gridy = 1;
    		gc.weightx = 0.0;
    		gbag.setConstraints(tempLabel, gc);
    		fakePanel.add(tempLabel);

    		fakeMaskTF = new JTextField(25);
    		fakeMaskTF.setMinimumSize(minDim);
    		fakeMaskTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
    		fakeMaskTF.getDocument().addDocumentListener(proxyConfig.changeListener);
    		gc.gridx = 1;
    		gc.gridy = 1;
    		gc.weightx = 1.0;
    		gbag.setConstraints(fakeMaskTF, gc);
    		fakePanel.add(fakeMaskTF);


    		add(Box.createVerticalGlue());
                		
    		JEditorPane dnsLB = new JEditorPane (
    		        "text/html",
    		        "<font face=\"arial\" color=\"blue\"><h2>DNS Request Ports"
    		        );
    		dnsLB.setMaximumSize(new Dimension(500,60));
    		dnsLB.setBackground (ProxyConfig.BACKGROUND_COLOR);
    		tempPanel = new JPanel();
            tempPanel.setLayout(new BoxLayout(tempPanel, BoxLayout.X_AXIS));
            add(tempPanel);
            tempPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
            tempPanel.add(dnsLB);
            
            HelpButton helpDNSBT = new HelpButton("HELP_DNS_PORT", this);
            tempPanel.add(Box.createRigidArea(new Dimension(5,5)));
            tempPanel.add(helpDNSBT);
            
            tempPanel.add(Box.createHorizontalGlue());

            JPanel dnsPanel = new JPanel();
            dnsPanel.setMaximumSize(new Dimension(300,100));
            dnsPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
            add(dnsPanel);
            
    		GridBagLayout dnsBag = new GridBagLayout();
    		dnsPanel.setLayout(dnsBag);

    		gc = new GridBagConstraints();
    		gc.weighty = 0.0;
    		gc.fill = GridBagConstraints.HORIZONTAL;
    		gc.insets = insets;
    		gc.gridx = GridBagConstraints.REMAINDER;
    		gc.anchor = GridBagConstraints.WEST;
    		
    		tempLabel = new JLabel("Standard DNS Port");
    		gc.gridx = 0;
    		gc.gridy = 0;
    		gc.weightx = 0.0;
    		dnsBag.setConstraints(tempLabel, gc);
    		dnsPanel.add(tempLabel);

    		stdDNSPortTF = new JTextField(10);
    		stdDNSPortTF.setMinimumSize(minDim);
    		stdDNSPortTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
    		stdDNSPortTF.getDocument().addDocumentListener(proxyConfig.changeListener);
    		gc.gridx = 1;
    		gc.gridy = 0;
    		gc.weightx = 1.0;
    		dnsBag.setConstraints(stdDNSPortTF, gc);
    		dnsPanel.add(stdDNSPortTF);

    		
    		tempLabel = new JLabel("Legacy DNS Request Port");
    		gc.gridx = 0;
    		gc.gridy = 1;
    		gc.weightx = 0.0;
    		dnsBag.setConstraints(tempLabel, gc);
    		dnsPanel.add(tempLabel);

    		legacyDNSPortTF = new JTextField(10);
    		legacyDNSPortTF.setMinimumSize(minDim);
    		legacyDNSPortTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
    		legacyDNSPortTF.getDocument().addDocumentListener(proxyConfig.changeListener);
    		gc.gridx = 1;
    		gc.gridy = 1;
    		gc.weightx = 1.0;
    		dnsBag.setConstraints(legacyDNSPortTF, gc);
    		dnsPanel.add(legacyDNSPortTF);
    		
            add(Box.createVerticalGlue());

            //Find the operating system.
            String osName = System.getProperty ("os.name", "windows").toLowerCase();
            if (ProxyConfig.isWindows()) {
                //windows

                add(Box.createVerticalGlue());
        		
                JEditorPane tunLB = new JEditorPane (
                        	"text/html",
                        	"<font face=\"arial\" color=\"blue\"><h2>Tunnel Network Connection"
                );
                tunLB.setMaximumSize(new Dimension(500,60));
                tunLB.setBackground (ProxyConfig.BACKGROUND_COLOR);
                tempPanel = new JPanel();
                tempPanel.setLayout(new BoxLayout(tempPanel, BoxLayout.X_AXIS));
                add(tempPanel);
                tempPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
                tempPanel.add(tunLB);
    
                HelpButton helpTunBT = new HelpButton("HELP_WIN_TUN", this);
                tempPanel.add(Box.createRigidArea(new Dimension(5,5)));
                tempPanel.add(helpTunBT);
    
                tempPanel.add(Box.createHorizontalGlue());

                JPanel tunPanel = new JPanel();
                tunPanel.setMaximumSize(new Dimension(300,100));
                tunPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
                add(tunPanel);
    
                GridBagLayout tunBag = new GridBagLayout();
                tunPanel.setLayout(tunBag);

                gc = new GridBagConstraints();
                gc.weighty = 0.0;
                gc.fill = GridBagConstraints.HORIZONTAL;
                gc.insets = insets;
                gc.gridx = GridBagConstraints.REMAINDER;
                gc.anchor = GridBagConstraints.WEST;
	
                tempLabel = new JLabel("Connection Name");
                gc.gridx = 0;
                gc.gridy = 0;
                gc.weightx = 0.0;
                tunBag.setConstraints(tempLabel, gc);
                tunPanel.add(tempLabel);

                winTunNameTF = new JTextField(30);
                winTunNameTF.setMinimumSize(minDim);
                winTunNameTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
                winTunNameTF.getDocument().addDocumentListener(proxyConfig.changeListener);
                gc.gridx = 1;
                gc.gridy = 0;
                gc.weightx = 1.0;
                tunBag.setConstraints(winTunNameTF, gc);
                tunPanel.add(winTunNameTF);
                winTunNameTF.setText(proxyConfig.proxyConfigData.winTunName);
            
                add(Box.createVerticalGlue());

            }
       
            fakeMaskTF.setText(proxyConfig.proxyConfigData.fakeAddrRangeMask);
            fakeStartTF.setText(proxyConfig.proxyConfigData.fakeAddrRangeStart);
            stdDNSPortTF.setText(proxyConfig.proxyConfigData.stdDNSRequestPort + "");
            legacyDNSPortTF.setText(proxyConfig.proxyConfigData.legacyDNSRequestPort + "");

            proxyConfig.changeListener.setEnabled(true);
        }
    
    
    void update() {
        
        proxyConfig.proxyConfigData.fakeAddrRangeMask = fakeMaskTF.getText();
        proxyConfig.proxyConfigData.fakeAddrRangeStart = fakeStartTF.getText();
        
        try {
            proxyConfig.proxyConfigData.stdDNSRequestPort = Integer.parseInt(stdDNSPortTF.getText());
        } catch (NumberFormatException nfe) {
            JOptionPane.showMessageDialog(null, "Invalid standard DNS port number." , "Number format error", JOptionPane.ERROR_MESSAGE);
        }
        
        try {
            proxyConfig.proxyConfigData.legacyDNSRequestPort = Integer.parseInt(legacyDNSPortTF.getText());
        } catch (NumberFormatException nfe) {
            JOptionPane.showMessageDialog(null, "Invalid legacy DNS request port number." , "Number format error", JOptionPane.ERROR_MESSAGE);
        }
        
        if (winTunNameTF != null) {
            proxyConfig.proxyConfigData.winTunName = winTunNameTF.getText();
        }

    }
    

    public void actionPerformed (ActionEvent ae) {
        
        String cmd = ae.getActionCommand();
        
        if (cmd.equals("HELP_FAKE_ADDR")) {
            
            JOptionPane.showMessageDialog(null,
    		        "The proxy uses fake IP addresses to masquerade as the remote end point to legacy applications. " +
    		        "\nThese fake IP addresses should be drawn from a pool of unused IP addresses on the local machine.",
    		        
    		        "Help: Fake IP Addresses",
    		        
    		        JOptionPane.INFORMATION_MESSAGE
    		        );

        } else if (cmd.equals("HELP_DNS_PORT")) {
            
            JOptionPane.showMessageDialog(null,
                    "The proxy captures DNS packets sent to the standard DNS request port (usually 53). " +
    		        "\nIn order to handle legacy URLs, the proxy also relays DNS requests to DNS servers from its legacy DNS request port.",                    
                    "Help: DNS Request Ports",
                    JOptionPane.INFORMATION_MESSAGE
                    );
        } else if (cmd.equals ("HELP_WIN_TUN")) {
            JOptionPane.showMessageDialog(null,
                    "Specify the Network Connection corresponding to the tunel device.",                    
                    "Help: DNS Request Ports",
                    JOptionPane.INFORMATION_MESSAGE
                    );
            
        }
    } 

}
