/*
 * Created on Oct 29, 2005
 */
package proxyconfig;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

import proxyconfig.i3.*;
import proxyconfig.rsptunnelocd.SecureConnectionWizardDialog;

/**
 * @author danjo
 */
public class WelcomeWizardDialog extends JDialog implements ActionListener {

    ProxyConfig proxyConfig;
    
    JRadioButton configureFullRadio;
    
    /** If user checks this checkbox, it means that the wizard dialog should not be shown 
     * again, the next time ProxyConfig starts up.
     */
    JCheckBox dontShowAgainCB;
    
    public WelcomeWizardDialog (ProxyConfig proxyConfig) {
        
        super(proxyConfig, "OCALA Configuration Wizard");
        
        setModal(true);
        
        this.proxyConfig = proxyConfig;
        
        
        setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
        
    	int xInsets = 250;
    	int yInsets = 250;
    	
    	//Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    	Dimension screenSize = new Dimension(1024,768);
    	
    	setResizable(false);
    	
    	setBounds(xInsets, yInsets, screenSize.width - xInsets*2, screenSize.height - yInsets * 2);
        
        Container contents = getContentPane();
        
        contents.setLayout(new BoxLayout(contents, BoxLayout.Y_AXIS));
        contents.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
        JPanel tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        contents.add(tmpPanel);
        
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));

        JEditorPane tmpLabel = new JEditorPane("text/html",
                 	"<font size=\"7\" color=\"blue\"><b>What would you like to do?</b></font");
        tmpLabel.setEditable(false);
        tmpLabel.setBackground (ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.add(tmpLabel);
        tmpLabel.setMaximumSize(new Dimension(200,50));

        tmpPanel.add( (Box.createHorizontalGlue()));
            
        contents.add(Box.createRigidArea(new Dimension(20,20)));
        
        // main panel start
        JPanel mainPanel = new JPanel();
        mainPanel.setLayout (new BoxLayout (mainPanel, BoxLayout.Y_AXIS));
        contents.add (mainPanel);

        contents.add (Box.createVerticalGlue());
        
        JPanel horizPanel = null;
        
       
        
       
        // START - Configure i3 NAT server
        JLabel tmpLB;
	tmpLB = new JLabel ("Set up a server behind NAT using i3");
        horizPanel = new JPanel();
        horizPanel.setLayout (new BoxLayout(horizPanel, BoxLayout.X_AXIS));
	horizPanel.add (Box.createRigidArea (new Dimension (30,10)));
	horizPanel.add (new HelpButton ("helpsnippets/WelcomeWizard_ConfigureNATServerI3.html", null, "Help"));
	horizPanel.add (Box.createRigidArea (new Dimension (15,10)));
        horizPanel.add (tmpLB);
	horizPanel.add (Box.createRigidArea (new Dimension (10,10)));
        
	JButton configureNATServerI3BT = new JButton ("Configure");
	configureNATServerI3BT.setActionCommand ("CONFIGURE_NAT_SERVER_I3");
	configureNATServerI3BT.addActionListener (this);
        horizPanel.add (Box.createHorizontalGlue());
	horizPanel.add (configureNATServerI3BT);
        horizPanel.add (Box.createRigidArea (new Dimension (100,10)));
        
	mainPanel.add(horizPanel);
        
        // END - Configure i3 NAT server

        
        // START - Configure OCALA Secure Connections
        tmpLB = new JLabel ("Configure OCALA Secure Connection");
        horizPanel = new JPanel();
        horizPanel.setLayout (new BoxLayout(horizPanel, BoxLayout.X_AXIS));
	horizPanel.add (Box.createRigidArea (new Dimension (30,10)));
	horizPanel.add (new HelpButton ("helpsnippets/WelcomeWizard_ConfigureSecureConnection.html", null, "Help"));
	horizPanel.add (Box.createRigidArea (new Dimension (15,10)));
        horizPanel.add (tmpLB);
	horizPanel.add (Box.createRigidArea (new Dimension (10,10)));
	JButton configureSecureConnectionBT = new JButton ("Configure");
	configureSecureConnectionBT.setActionCommand ("CONFIGURE_SECURE_CONNECTION");
	configureSecureConnectionBT.addActionListener (this);
        horizPanel.add (Box.createHorizontalGlue());
	horizPanel.add (configureSecureConnectionBT);
        horizPanel.add (Box.createRigidArea (new Dimension (100,10)));
        mainPanel.add(horizPanel);
        
	// END - Configure i3 NAT server

        // START - Configure Expert Mode
        tmpLB = new JLabel ("Configure OCALA in Expert Mode");
        horizPanel = new JPanel();
        horizPanel.setLayout (new BoxLayout(horizPanel, BoxLayout.X_AXIS));
	horizPanel.add (Box.createRigidArea (new Dimension (30,10)));
	horizPanel.add (new HelpButton ("helpsnippets/WelcomeWizard_ConfigureExpertMode.html", null, "Help"));
	horizPanel.add (Box.createRigidArea (new Dimension (15,10)));
        horizPanel.add (tmpLB);
	horizPanel.add (Box.createRigidArea (new Dimension (10,10)));
	JButton configureExpertModeBT = new JButton ("Configure");
	configureExpertModeBT.setActionCommand ("CONFIGURE_EXPERT_MODE");
	configureExpertModeBT.addActionListener (this);
        horizPanel.add (Box.createHorizontalGlue());
	horizPanel.add (configureExpertModeBT);
        horizPanel.add (Box.createRigidArea (new Dimension (100,10)));
        mainPanel.add(horizPanel);
        
	// END - Configure Expert Mode
	// 
        // START - Configure full
        configureFullRadio = new JRadioButton ("Configure the proxy in detail");
        horizPanel = new JPanel();
        horizPanel.setLayout (new BoxLayout(horizPanel, BoxLayout.X_AXIS));
        horizPanel.add (configureFullRadio);
	horizPanel.add (new HelpButton ("helpsnippets/WelcomeWizard_ConfigureProxyInDetail.html", null, "Help"));
        horizPanel.add (Box.createHorizontalGlue());
        //mainPanel.add(horizPanel);
        // END - Configure full
 
        // main panel end
        
        JPanel buttonPanel = new JPanel();
        buttonPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);

        contents.add(Box.createRigidArea(new Dimension(5,5)));
        contents.add(buttonPanel);


        JButton cancelBT = new JButton("DONE");
        cancelBT.setActionCommand("QUIT");
        cancelBT.addActionListener (this);

        buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
        buttonPanel.add(Box.createHorizontalGlue());
        buttonPanel.add(Box.createRigidArea(new Dimension(10,10)));
        buttonPanel.add(cancelBT);
        buttonPanel.add(Box.createHorizontalGlue());

        
        //horizPanel = new JPanel();
        //horizPanel.setLayout (new BoxLayout(horizPanel, BoxLayout.X_AXIS));
        mainPanel.add (Box.createVerticalGlue());
        //mainPanel.add(horizPanel);
        
        dontShowAgainCB = new JCheckBox ("Do not show this wizard again");
        dontShowAgainCB.setSelected(false);
        //horizPanel.add (dontShowAgainCB);
        
        //horizPanel.add (Box.createHorizontalGlue());
        
	contents.add (Box.createRigidArea (new Dimension (10,10)));	
        
    }
    
    public void actionPerformed (ActionEvent ae) {
        
        String cmd = ae.getActionCommand();
        
        updateDontShowAgainStatus();
        
        if (cmd.equals ("CONFIGURE_SECURE_CONNECTION")) {
            setVisible (false);
            SecureConnectionWizardDialog secureConnectionWizard = new SecureConnectionWizardDialog (proxyConfig);
            secureConnectionWizard.show();
            setVisible (true);
	} else if (cmd.equals ("CONFIGURE_NAT_SERVER_I3")) {    
                
            setVisible (false);
	    NATServerWizardDialog natServerWizardDialog = new NATServerWizardDialog(proxyConfig);
            natServerWizardDialog.show();
            setVisible (true);
	} else if (cmd.equals ("CONFIGURE_EXPERT_MODE")) {
	    
            setVisible (false);
	    configureExpertMode();
            setVisible (true);
        } else if (cmd.equals ("QUIT")) {
           
            if (proxyConfig.mRestartFlag) {
              proxyConfig.promptRestart();
            }
            
            setVisible (false);
            System.exit(0);
        }
    }
    
    private void configureExpertMode () {

        URL helpURL = null;
        try {
            JEditorPane mainEditorPane = new JEditorPane ();
           
            helpURL = getClass().getResource("/helpsnippets/WelcomeWizard_ConfigureExpertMode.html");
            mainEditorPane.setPage (helpURL);
            mainEditorPane.setEditable(false);
            //mainEditorPane.addHyperlinkListener(this);
            
            JScrollPane scrollPane = new JScrollPane (mainEditorPane);
	    	scrollPane.setPreferredSize (new Dimension (400,550));
	    	JOptionPane.showMessageDialog ( null, 
					scrollPane,
					"Configure Expert Mode",
					JOptionPane.INFORMATION_MESSAGE
				);
        } catch (IOException ioe) {
	    	System.out.println ( "Unable to display Expert Mode configuration installation information " + helpURL + " : " + ioe);
	    	ioe.printStackTrace();
	}
    }

    public static void changeOptionPaneBackground(Color c) {
    }
    /**
     * Depending on the status of dontShowCheckBox,
     * update the first time file.
     */
    private void updateDontShowAgainStatus () {
        if (dontShowAgainCB.isSelected()) {
            proxyConfig.setFirstTime();
        }
    }

}

