/*
 * Created on May 25, 2005
 */
package proxyconfig;

import javax.swing.*;

import java.awt.Dimension;
import java.awt.event.*;

/**
 * @author danjo
 */
public class WizardFinishPanel extends JPanel implements ActionListener {

    ProxyConfigWizard wiz;
    JCheckBox startProxyCB;
    
    public WizardFinishPanel (ProxyConfigWizard  wiz) {
        
        this.wiz = wiz;
        
        setBackground (ProxyConfig.WHITE_COLOR);
        
        setLayout (new BoxLayout(this, BoxLayout.Y_AXIS));
        
        add(Box.createVerticalGlue());
        
        JPanel horizPanel = new JPanel();
        horizPanel.setLayout (new BoxLayout(horizPanel, BoxLayout.X_AXIS));
        horizPanel.setBackground (ProxyConfig.WHITE_COLOR);
        add(horizPanel);
        
        JEditorPane headerMsg = new JEditorPane ( "text/html",
                "<div align=\"left\"><font face=\"arial\" color=\"blue\" size=\"5\">" +
                	"Click on the button below for advanced configuration options or simply press the FINISH button to exit." +
                "</font>"
        	);
        headerMsg.setPreferredSize(new Dimension(600,60));
        headerMsg.setMaximumSize(new Dimension(600,60));
        
        horizPanel.add(headerMsg);
        horizPanel.add (Box.createHorizontalGlue());
        
        horizPanel = new JPanel();
        horizPanel.setLayout (new BoxLayout(horizPanel, BoxLayout.X_AXIS));
        horizPanel.setBackground (ProxyConfig.WHITE_COLOR);
        
        horizPanel.add(Box.createHorizontalGlue());
        add(horizPanel);
        
        JButton advancedBT = new JButton ("Advanced Settings");
        advancedBT.addActionListener (this);
        advancedBT.setActionCommand ("ADVANCED");
        horizPanel.add(advancedBT);
        
        horizPanel.add(Box.createHorizontalGlue());
        
        
        add (Box.createVerticalGlue());
        
        horizPanel = new JPanel();
        horizPanel.setLayout (new BoxLayout(horizPanel, BoxLayout.X_AXIS));
        horizPanel.setBackground (ProxyConfig.WHITE_COLOR);
        
        startProxyCB = new JCheckBox ("Start proxy on exit.");
        startProxyCB.setBackground (ProxyConfig.WHITE_COLOR);
        horizPanel.add (startProxyCB);
        
        horizPanel.add(Box.createHorizontalGlue());
        //add(horizPanel);
        
        
        add(Box.createVerticalGlue());
        
    }
    
    public void actionPerformed (ActionEvent ae) {
        
        String cmd = ae.getActionCommand();
        if (cmd.equals ("ADVANCED")) {
            wiz.showAdvancedConfig();
        }
    }
}
