/*
 * Created on May 25, 2005
 */
package proxyconfig;

import java.awt.Dimension;
import java.util.ListIterator;

import javax.swing.*;
import java.awt.event.*;

import proxyconfig.ocd.OCD;

/**
 * @author danjo
 */
public class WizardOverlayPanel extends JPanel implements ActionListener {

    ProxyConfig proxyConfig;
    
    public WizardOverlayPanel (ProxyConfig proxyConfig) {
    
        this.proxyConfig = proxyConfig;
        
        setLayout (new BoxLayout(this, BoxLayout.Y_AXIS));
        
        setBackground (proxyconfig.ProxyConfig.WHITE_COLOR);
        
        JEditorPane welcomeLB = new JEditorPane();
        welcomeLB.setContentType("text/html");
        welcomeLB.setMaximumSize (new Dimension(700, 150));
        welcomeLB.setEditable(false);
        
        String welcomeStr1 = 
            "<br>" + "<font face=\"arial\">" +
             "<font size=\"6\" ><b>Welcome to the Generic Proxy Configurator!</b></font><br><br>" +
             "The following overlay networks are currently available in the proxy."
             ;
             
                
        welcomeLB.setText(welcomeStr1);

        add(welcomeLB);

        add(Box.createRigidArea (new Dimension(50,50)));
        
        ListIterator itr = proxyConfig.proxyConfigData.overlayList.listIterator();
        while (itr.hasNext()) {
            OCD currOverlay = (OCD) itr.next();
            JPanel horizPanel = new JPanel();
            horizPanel.setBackground(proxyconfig.ProxyConfig.WHITE_COLOR);
            add(horizPanel);
            
            horizPanel.setLayout(new BoxLayout(horizPanel, BoxLayout.X_AXIS));
            
            horizPanel.add (Box.createHorizontalGlue());
            
            JEditorPane overlayLB = new JEditorPane ( "text/html",
                    "<div align=\"left\"><font face=\"arial\" color=\"blue\" size=\"5\">" +
                    	currOverlay  +
                    "</font>"
            	);
            overlayLB.setPreferredSize(new Dimension(160,30));
            overlayLB.setMaximumSize(new Dimension(160,30));
            
            horizPanel.add(overlayLB);
            
            JCheckBox overlayCB = new JCheckBox();
            overlayCB.setBackground (ProxyConfig.WHITE_COLOR);
            overlayCB.setActionCommand (currOverlay.id);
            overlayCB.addActionListener (this);
            
            if (currOverlay.isActive) {
                overlayCB.setSelected (true);
            }
            
            horizPanel.add (Box.createRigidArea (new Dimension(10,10)));
            horizPanel.add(overlayCB);
            
            horizPanel.add (Box.createHorizontalGlue());
            
        }
        
        add (Box.createVerticalGlue());

    }
    
    public void actionPerformed (ActionEvent ae) {
        
        String cmd = ae.getActionCommand();
        
        OCD currOCD = proxyConfig.proxyConfigData.getOverlayById(cmd);
        
        JCheckBox srcCB = (JCheckBox) ae.getSource();
        if (srcCB.isSelected()) {
            currOCD.isActive = true;
        } else {
            currOCD.isActive = false;
        }
    }
}
