/*
 * Created on Oct 29, 2005
 */
package proxyconfig.certificate;

import java.awt.*;
import java.awt.event.*;
import java.io.File;

import javax.swing.*;
import javax.swing.border.BevelBorder;

import proxyconfig.ProxyConfig;
import proxyconfig.mynames.MyName;
import java.io.*;

/**
 * @author danjo
 */
public class CertificateEditPanel extends JPanel implements ActionListener {

    ProxyConfig proxyConfig;
    JTextField certTF;
    JTextField privKeyTF;
    
    JTextField nameTF;

    
    /**
     * 
     * @param proxyConfig
     * @param currName
     * @param nameTF Pointer to a text field containing the name to be used for the wizard
     */
    public CertificateEditPanel (ProxyConfig proxyConfig, MyName currName, JTextField nameTF) {
    
        this.proxyConfig = proxyConfig;
        this.nameTF = nameTF;
        
		Dimension minDim = new Dimension(50, 25);
        
        setLayout (new BoxLayout (this, BoxLayout.Y_AXIS));
        
        JPanel cert1Panel = new JPanel ();
		cert1Panel.setBackground (proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		cert1Panel.setLayout (new BoxLayout (cert1Panel, BoxLayout.Y_AXIS));
		cert1Panel.setBorder (BorderFactory.createTitledBorder( 
	        	BorderFactory.createLineBorder (Color.BLACK), 
	        	"Certificate for this name"
	        	)
	        );
		add(cert1Panel);

		JPanel tmpPanel = null;
		JLabel tempLabel = null;
		
		tmpPanel = new JPanel();
		tmpPanel.setLayout(new BoxLayout (tmpPanel, BoxLayout.X_AXIS));
		tmpPanel.add (Box.createHorizontalGlue());
		tempLabel = new JLabel("Either use the Certificate Wizard or manually specify the certificate and private key files");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		tmpPanel.add(tempLabel);
		tmpPanel.add (Box.createHorizontalGlue());
		//cert1Panel.add(tmpPanel);

		JPanel certPanel = new JPanel();
		
		certPanel.setLayout(new BoxLayout(certPanel, BoxLayout.X_AXIS));
		certPanel.setBackground (proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		//cert1Panel.add(Box.createVerticalGlue());
		cert1Panel.add(certPanel);
		//cert1Panel.add(Box.createVerticalGlue());
		
				
		JButton wizardBT = new JButton ("<html><center>Certificate<br>Wizard</center></html>");
		wizardBT.addActionListener(this);
		wizardBT.setActionCommand ("WIZARD");
		certPanel.add(wizardBT);
		
		
		JLabel orLB = new JLabel (" OR ");
		orLB.setBackground (proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		//certPanel.add (orLB);
		
		JPanel manualCertPanel = new JPanel();
		manualCertPanel.setBorder (BorderFactory.createBevelBorder(BevelBorder.LOWERED));
		GridBagLayout gbag2 = new GridBagLayout();
		manualCertPanel.setLayout (gbag2);
		//certPanel.add(manualCertPanel);
		
		
		GridBagConstraints gc = new GridBagConstraints();
		
		tempLabel = new JLabel("Certificate");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0.0;
		gbag2.setConstraints(tempLabel, gc);
		manualCertPanel.add(tempLabel);

		
		tmpPanel = new JPanel();
		tmpPanel.setLayout (new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
		
		certTF = new JTextField(20);
		tmpPanel.add(certTF);
		tmpPanel.add(Box.createRigidArea(new Dimension(5,5)));
		
		certTF.setMinimumSize(minDim);
		certTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		
		JButton certBT = new JButton ("Change");
		certBT.setActionCommand ("CHANGE_CERT");
		certBT.addActionListener (this);
		tmpPanel.add (certBT);
		
		gc.gridx = 1;
		gc.gridy = 0;
		gc.weightx = 1.0;
		gbag2.setConstraints(tmpPanel, gc);
		manualCertPanel.add(tmpPanel);

		tempLabel = new JLabel("Private Key");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 1;
		gc.weightx = 0.0;
		gbag2.setConstraints(tempLabel, gc);
		manualCertPanel.add(tempLabel);

		tmpPanel = new JPanel();
		tmpPanel.setLayout (new BoxLayout(tmpPanel, BoxLayout.X_AXIS));

		privKeyTF = new JTextField(20);
		tmpPanel.add(privKeyTF);
		tmpPanel.add(Box.createRigidArea(new Dimension(5,5)));

		privKeyTF.setMinimumSize(minDim);
		privKeyTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		
		JButton privKeyBT = new JButton ("Change");
		privKeyBT.setActionCommand ("CHANGE_PRIV_KEY");
		privKeyBT.addActionListener (this);
		tmpPanel.add (privKeyBT);
		
		gc.gridx = 1;
		gc.gridy = 1;
		gc.weightx = 1.0;
		gbag2.setConstraints(tmpPanel, gc);
		manualCertPanel.add(tmpPanel);
	
		if (currName != null) {
		    privKeyTF.setText (currName.privKeyFileName);
		    certTF.setText (currName.certFileName);
		}
    }
    
    public void actionPerformed (ActionEvent ae) {
        
        	String cmd = ae.getActionCommand();
        
        	if (cmd.equals("CHANGE_CERT")) {
        	    
        	    int retVal = proxyConfig.fc.showOpenDialog(proxyConfig);
        	    if (retVal == JFileChooser.APPROVE_OPTION) {
        	        certTF.setText(proxyConfig.fc.getSelectedFile().getPath());
        	    }
        	    
        	} else if (cmd.equals("CHANGE_PRIV_KEY")) {
            	    
           	    int retVal = proxyConfig.fc.showOpenDialog(proxyConfig);
            	if (retVal == JFileChooser.APPROVE_OPTION) {
            	    privKeyTF.setText(proxyConfig.fc.getSelectedFile().getPath());
            	}
           	} else if (cmd.equals ("WIZARD")) {
                
           	    CertificateWizard certWiz = new CertificateWizard(proxyConfig, nameTF.getText());
                if (certWiz.finishFlag) {
                    
                    if (certWiz.changeListener.hasChanged()) {
                        certTF.setText(certWiz.getCertificateFileName());
                        privKeyTF.setText(certWiz.getPrivKeyFileName());
                        
                        proxyConfig.changeListener.setChanged(true);
                    }
                }
           	}
        }


    public String getCertificateFileName() {
        return certTF.getText();
    }
    
    public String getPrivKeyFileName() {
        return privKeyTF.getText();
    }
    
}
