/*
 * Created on Jan 22, 2005
 */
package proxyconfig.i3;

import java.util.*;
import java.io.*;
import javax.swing.*;

/**
 * @author danjo
 */
public class I3AddressBook {

    ArrayList addressList = new ArrayList();
    
    I3AddressBook() {
        
    }
    
    I3AddressBook (I3AddressBook b) {
        addressList = new ArrayList();
        ListIterator itr = b.addressList.listIterator();
        while (itr.hasNext()) {
            addressList.add(new I3AddressBookEntry((I3AddressBookEntry) itr.next()));
        }
    }
    
    I3AddressBookEntry getEntry(String name) {
        ListIterator itr = addressList.listIterator();
        while (itr.hasNext()) {
            
            I3AddressBookEntry tmpEntry = (I3AddressBookEntry) itr.next();
            if (tmpEntry.name.equals(name)) {
                return tmpEntry;
            } 
        }
        
        return null;
    }
    
    void loadFromFile(String fileName) {
        
        try {
            BufferedReader br = new BufferedReader (new FileReader(fileName));
            
            String line = null;
            
            while ( (line = br.readLine()) != null) {
                if (line.trim().equals("")) {
                    continue;
                }
                StringTokenizer st = new StringTokenizer(line, " \t");
                addressList.add(new I3AddressBookEntry(st.nextToken(), st.nextToken()));
            }
            
        } catch (IOException ioe) {
            
            JOptionPane.showMessageDialog(null,
                    "Unable to load I3 Address Book from file " + fileName + ".",
                    "File Load Error",
                    JOptionPane.ERROR_MESSAGE);
            
        }
        
    }
    
    boolean contains(I3AddressBookEntry entry) {
        ListIterator itr = addressList.listIterator();
        while (itr.hasNext()) {
            I3AddressBookEntry tmpEntry = (I3AddressBookEntry) itr.next();
            if (tmpEntry.name.trim().toLowerCase().equals(entry.name.trim().toLowerCase())) {
                return true;
            }
        }
        
        return false;
    }
}
