/*
 * Created on Jan 22, 2005
 */
package proxyconfig.i3;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.*;

import proxyconfig.ProxyConfig;

import java.awt.*;

/**
 * @author danjo
 */
public class I3ServerEditPanel extends JPanel {

    JTextField ipTF;
    JTextField i3IdTF;
    JTextField portTF;
    
    I3ServerEditPanel() {
        
        setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
    	//Construct the GUI
		Insets insets = new Insets(2,2,2,2);
		GridBagLayout gbag = new GridBagLayout();
		setLayout(gbag);

		GridBagConstraints gc = new GridBagConstraints();
		gc.weighty = 0.0;
		gc.fill = GridBagConstraints.HORIZONTAL;
		gc.insets = insets;
		gc.gridx = GridBagConstraints.REMAINDER;
		gc.anchor = GridBagConstraints.WEST;

		
		JLabel tempLabel;

		// The preferred Dimension of all the input fields - mainly used to enforce a common height
		Dimension minDim = new Dimension(50, 25);
		
		tempLabel = new JLabel("IP Address");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);

		ipTF = new JTextField(15);
		ipTF.setMinimumSize(minDim);
		ipTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		
		gc.gridx = 1;
		gc.gridy = 0;
		gc.weightx = 1.0;
		gbag.setConstraints(ipTF, gc);
		add(ipTF);

		tempLabel = new JLabel("Port Number");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 1;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);
	    
		portTF = new JTextField(10);
		portTF.setMinimumSize(minDim);
		portTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		gc.gridx = 1;
		gc.gridy = 1;
		gc.weightx = 1.0;
		gbag.setConstraints(portTF, gc);
		add(portTF);

		
		tempLabel = new JLabel("I3 Id");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 2;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);
	    
		i3IdTF = new JTextField(30);
		i3IdTF.setMinimumSize(minDim);
		i3IdTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		gc.gridx = 1;
		gc.gridy = 2;
		gc.weightx = 1.0;
		gbag.setConstraints(i3IdTF, gc);
		add(i3IdTF);

    }
    
    void setServer(I3Server s) {
        ipTF.setText(s.ipAddress);
        i3IdTF.setText(s.i3Id);
        portTF.setText("" + s.portNum);
    }
    
    boolean updateServer(I3Server currServer) {
        currServer.ipAddress = ipTF.getText();
        currServer.i3Id = i3IdTF.getText();
        
        try {
            currServer.portNum = Integer.parseInt(portTF.getText());
            
        } catch (NumberFormatException nfe) {
            
            return false; 
        }
        
        return true;
    
    }
    
    boolean checkFields() {
        boolean retVal = true;
        
        String msg = "";
        
        if (i3IdTF.getText().trim().equals("")) {
            retVal = false;
            msg += "I3 Id field should not be empty.\n";
        }
        
        if (ipTF.getText().trim().equals("")) {
            retVal = false;
            msg += "IP Address field should not be empty.\n";
        }
        
        try {
            Integer.parseInt(portTF.getText());
            
        } catch (NumberFormatException nfe) {
            retVal = false;
            msg += "Invalid port number.";
            
        }
        
        if (! retVal) {
            JOptionPane.showMessageDialog( null,
                msg,
             	"Invalid I3 Server",
             	JOptionPane.ERROR_MESSAGE
        	);
        }
        
        return retVal;

    }
}
