/*
 * Created on Oct 29, 2005
 */
package proxyconfig.i3;

import java.awt.Dimension;

import javax.swing.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;

import proxyconfig.mynames.*;
import proxyconfig.*;

/**
 * @author danjo
 */
public class I3TriggerLimitPanel extends JPanel implements ChangeListener {
   
    JTextField totalBWTF;
    JCheckBox bwRateLimitCB;
    
    JCheckBox maxConnectionsCB;
    JTextField maxConnectionsTF;
    
   
    public I3TriggerLimitPanel (MyName rec, InputChangeListener changeListener) {

        changeListener.setEnabled (false);
        
        setLayout (new BoxLayout (this, BoxLayout.Y_AXIS));
        
		// bwPanel start
		JPanel bwPanel = new JPanel();
		bwPanel.setLayout (new BoxLayout (bwPanel, BoxLayout.X_AXIS));
		add(bwPanel);
		    
		bwRateLimitCB = new JCheckBox ("Limit total bandwidth to");
		bwPanel.add (bwRateLimitCB);
		bwRateLimitCB.addChangeListener(this);
		bwRateLimitCB.addChangeListener (changeListener);
		
		bwPanel.add (Box.createRigidArea (new Dimension(5,5)));
		    
		totalBWTF = new JTextField (10);
		totalBWTF.setMaximumSize (new Dimension(50,20));
		totalBWTF.setPreferredSize (new Dimension(50,20));
		totalBWTF.setEnabled (bwRateLimitCB.isSelected());
		totalBWTF.getDocument().addDocumentListener(changeListener);
		bwPanel.add(totalBWTF);
		    
		bwPanel.add (Box.createRigidArea (new Dimension(5,5)));
		    
		bwPanel.add (new JLabel ("KBps"));
		    
		bwPanel.add (Box.createHorizontalGlue());
		// bwPanel end

		    
		// max connections panel start
		JPanel maxConnectionsPanel = new JPanel();
		maxConnectionsPanel.setLayout (new BoxLayout (maxConnectionsPanel, BoxLayout.X_AXIS));
		add(maxConnectionsPanel);
		   
		maxConnectionsCB = new JCheckBox ("Limit total number of connections to ");
		maxConnectionsPanel.add (maxConnectionsCB);
		maxConnectionsCB.addChangeListener(this);
		maxConnectionsCB.addChangeListener (changeListener);
		
		maxConnectionsPanel.add (Box.createRigidArea (new Dimension(5,5)));
		    
		maxConnectionsTF = new JTextField (10);
		maxConnectionsTF.setMaximumSize (new Dimension(50,25));
		maxConnectionsTF.setPreferredSize (new Dimension(50,25));
		maxConnectionsTF.setEnabled (maxConnectionsCB.isSelected());
		maxConnectionsTF.getDocument().addDocumentListener(changeListener);
		maxConnectionsPanel.add(maxConnectionsTF);
		   
		maxConnectionsPanel.add (Box.createRigidArea (new Dimension(5,5)));
		    
		maxConnectionsPanel.add (new JLabel ("per minute"));
		    
		maxConnectionsPanel.add (Box.createHorizontalGlue());
		// max connections panel
	
		setMyName (rec);
		
		
		changeListener.setEnabled (true);

    }

    void setMyName (MyName rec) {
		if (rec != null) {
		    
		    String tmpBW = (String) rec.ocdSpecificProperties.get (I3OCD.I3_TRIGGER_TOTAL_BW);
		    if (tmpBW != null && !tmpBW.trim().equals("")) {
		        bwRateLimitCB.setSelected(true);
		        totalBWTF.setText (tmpBW);
		    }
		    
		    String tmpConn = (String) rec.ocdSpecificProperties.get (I3OCD.I3_TRIGGER_TOTAL_CONNECTIONS);
		    if (tmpConn != null && !tmpConn.trim().equals("")) {
		        maxConnectionsCB.setSelected(true);
		        maxConnectionsTF.setText(tmpConn);
		    }
		    
		}
    }
    
    /**
     * This function is called when one of the check boxes is ticked or unticked
     */
    public void stateChanged(ChangeEvent e) {
        if (e.getSource() == bwRateLimitCB) {
            // bw rate limit checkbox
            totalBWTF.setEnabled (bwRateLimitCB.isSelected());            
        } else if (e.getSource() == maxConnectionsCB) {
            maxConnectionsTF.setEnabled (maxConnectionsCB.isSelected());
        }
        
    }
    
    /**
     * Checks if all fields are okay.  If yes, returns "".  Else returns appropriate error message.
     * @return
     */
    String checkFields () {
        
        String retStr = "";
    
        if (bwRateLimitCB.isSelected()) {
            
            try {
                Integer.parseInt( (totalBWTF.getText()));
            } catch (NumberFormatException nfe) {
                retStr += "Invalid bandwidth limit.\n";
                nfe.printStackTrace();
            }
        }
        
        if (maxConnectionsCB.isSelected()) {
            
            try {
                Integer.parseInt( (maxConnectionsTF.getText()));
            } catch (NumberFormatException nfe) {
                retStr += "Invalid value for max connections.\n";
                nfe.printStackTrace();
            }
        }

        return retStr;
    }
    
    void update (MyName rec) {
        
        if (maxConnectionsCB.isSelected()) {
            rec.ocdSpecificProperties.put (I3OCD.I3_TRIGGER_TOTAL_CONNECTIONS, maxConnectionsTF.getText());
        }
        
        if (bwRateLimitCB.isSelected()) {
            rec.ocdSpecificProperties.put (I3OCD.I3_TRIGGER_TOTAL_BW, totalBWTF.getText());
        }
    
    }
}
