/*
 * Created on May 16, 2005
 */
package proxyconfig.mynames;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.table.DefaultTableCellRenderer;

import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import java.util.*;
import java.io.*;

import proxyconfig.*;
import proxyconfig.ocd.OCD;

/**
 * @author danjo
 */
public class MyNamePanel extends JPanel implements ActionListener {
    MyNameTable myNameTable;
    MyNameTableModel tableModel;
    
    HashMap activeChkBoxMap = new HashMap();
    
    ProxyConfig proxyConfig;
    
    public MyNamePanel(ProxyConfig proxyConfig) {
        
        this.proxyConfig = proxyConfig;
        proxyConfig.changeListener.setEnabled(false);
        
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        
        setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
        setBorder(BorderFactory.createLineBorder(Color.BLACK));

        JPanel tmpPanel;
        
        /*
        tmpPanel = new JPanel();
        tmpPanel.setBackground(Color.WHITE);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        add(tmpPanel);
        JEditorPane overlayTitleLB = new JEditorPane("text/html",
                "Available overlays"
                );
        overlayTitleLB.setBackground(Color.WHITE);
        overlayTitleLB.setMaximumSize(new Dimension(500,120));
        overlayTitleLB.setEditable(false);
        tmpPanel.add(Box.createHorizontalGlue());
        tmpPanel.add(overlayTitleLB);
        tmpPanel.add(Box.createHorizontalGlue());

        add(Box.createRigidArea(new Dimension(15,15)));

        */
        
        add(new MessageLabel(
                "My Names", 
                ProxyConfig.HEADING_COLOR, 	//background color
                24 //font size
                ));
        
        
        add(Box.createRigidArea(new Dimension(10,10)));

        
        /*
        tmpPanel = new JPanel();
        tmpPanel.setBackground(Color.WHITE);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        add(tmpPanel);
        JEditorPane titleLB = new JEditorPane("text/html",
                "Here you can configure the overlay which should handle URLs satisfying specific patterns.  " +
                "For example, you may want all URLs of the form *.mil to go through an overlay X and URLs of the form " +
                "*berkeley* to be handled by some other overlay Y. " +
                "<br><br>The arrows on the side of the table are used to order the rules.  When deciding the overlay to use for a particular URL, the proxy scans the list from top to bottom and stops at the first match."
                
                );
        titleLB.setBackground(Color.WHITE);
        titleLB.setMaximumSize(new Dimension(500,120));
        titleLB.setEditable(false);
        tmpPanel.add(titleLB);
        tmpPanel.add(Box.createHorizontalGlue());

        add(Box.createRigidArea(new Dimension(15,15)));
        
        */
        JPanel contentPanel = new JPanel();
        contentPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
        contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.Y_AXIS));
        add(contentPanel);

        
        JPanel tablePanel = new JPanel();
        
        tablePanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tablePanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
        tablePanel.setLayout(new BoxLayout(tablePanel, BoxLayout.X_AXIS));
        contentPanel.add(tablePanel);
        
        String columns[] = {"Name","Overlay", "Certificate Status"};
        
        tableModel = new MyNameTableModel(columns);
        
        myNameTable = new MyNameTable(tableModel);
        myNameTable.setPreferredSize(new Dimension(500,450));
        JScrollPane urlTableScroller = new JScrollPane(myNameTable);
        urlTableScroller.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tablePanel.add(urlTableScroller);
        
        
        LinkedList buttonList = new LinkedList();
        
        JButton addBT = new JButton("Add New Name");
        addBT.setActionCommand("ADD_NAME");
        addBT.addActionListener(this);
        buttonList.add(addBT);

        JButton editBT = new JButton("Modify Selected Name");
        editBT.setActionCommand("EDIT_NAME");
        editBT.addActionListener(this);
        buttonList.add(editBT);

        JButton delBT = new JButton("Delete Selected Name");
        delBT.setActionCommand("DEL_NAME");
        delBT.addActionListener(this);
        buttonList.add(delBT);

        add(Box.createRigidArea(new Dimension(10,10)));
        
        CenteredButtonPanel buttonPanel = new CenteredButtonPanel(buttonList, new Dimension(5,5));
        buttonPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        contentPanel.add(buttonPanel);    
        
        
        Iterator itr = proxyConfig.proxyConfigData.myNameList.listIterator();
        while (itr.hasNext()) {
            MyName tmpRecord = (MyName) itr.next();
            tableModel.addRecord(tmpRecord);
        }

    }
    
    public void updateMyNameList() {
        tableModel.clear();
        Iterator itr = proxyConfig.proxyConfigData.myNameList.listIterator();
        while (itr.hasNext()) {
            MyName tmpRecord = (MyName) itr.next();
            tableModel.addRecord(tmpRecord);
        }
    }

    void refreshOverlay(OCD o) {
        
        ListIterator itr = tableModel.getRecordList().listIterator();
        while (itr.hasNext()) {
            
            MyName r = (MyName) itr.next();
            /*if (r.overlay != null && r.overlay.id.equals(o.id )){
                r.overlay =o;
                r.overlayId = o.id;
            }*/
            
        }
        tableModel.fireTableDataChanged();
        
       
    }
    
    
    void checkOverlay(OCD chkOverlay, JCheckBox currCheckBox) {
    
        boolean invalidFlag = false;
    /*    
        ListIterator itr = tableModel.getRecordList().listIterator();
        while (itr.hasNext()) {
            URLRecord tmpRec = (URLRecord) itr.next();
            if ( !chkOverlay.isActive && 
                    (tmpRec.overlayId.equals(chkOverlay.id) || tmpRec.overlay == chkOverlay)
                    ) {
                invalidFlag = true;
            }
        }
        
        if (invalidFlag) {
            int retVal = JOptionPane.showConfirmDialog(null,
                    "There are URLs mapping to the inactive overlay " + chkOverlay.id + "." +
                    "\nAre you sure you want to inactivate this overlay?",
                    "Invalid URL mappings",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.WARNING_MESSAGE
                    );
            
            if (retVal == JOptionPane.NO_OPTION) {
                currCheckBox.setSelected(true);
                chkOverlay.isActive = true;
            }
        
        }
        tableModel.fireTableDataChanged();
        */
    }
    
    void update() {
        
        proxyConfig.proxyConfigData.myNameList = tableModel.getRecordList();
    }
    
    public void actionPerformed(ActionEvent ae) {
        
        String cmd = ae.getActionCommand();
        
        if (cmd.equals ("ADD_NAME")) {

            ProxyConfig.changeOptionPaneBackground(Color.WHITE);

            MyNameEditPanel myNameEditPanel = new MyNameEditPanel (null, proxyConfig);
            
            do {
                int retVal = JOptionPane.showConfirmDialog(
                		null, 
                		myNameEditPanel, 
                		"Add New Name", 
                		JOptionPane.OK_CANCEL_OPTION
                	);
                
            	if (retVal == JOptionPane.OK_OPTION) {
                
                	if (myNameEditPanel.checkFields()) {
                
                        MyName currRecord = new MyName();
                        	
                        myNameEditPanel.updateRecord(currRecord);
                        
                    	// check for certificates
                    	File tmpCertFile = new File (currRecord.certFileName);
                    	String certMsg = "";
                    	if (! tmpCertFile.exists()) {
                    	    certMsg += "Certificate file " + tmpCertFile.getPath() + " does not exist.\n";
                    	    currRecord.certOKFlag = MyName.CERT_NOT_FOUND;
                    	}
                    	
                    	File tmpPrivKeyFile = new File (currRecord.privKeyFileName);
                    	if (! tmpPrivKeyFile.exists()) {
                    	    certMsg += "Private key file " + tmpPrivKeyFile.getPath() + " does not exist.\n";
                    	    currRecord.certOKFlag = MyName.CERT_NOT_FOUND;
                    	}
                    	
                    	if ( ! certMsg.equals("")) {
                    	    certMsg += "\nSince the certificate for name " + currRecord.name + " has not been " 
                    	    			+ "correctly setup, \npeople will not be able to contact you on this name securely."
                    	    			+ "\nDo you want to specify the certificate again?";
                    	    
                    	    int certRetVal = JOptionPane.showConfirmDialog( null,
                                    certMsg,
                                    "Certificate Error",
                                    JOptionPane.YES_NO_OPTION
                        		);
                    	    if (certRetVal == JOptionPane.NO_OPTION) {
                    	        proxyConfig.proxyConfigData.myNameList.add(currRecord);
                                tableModel.addRecord(currRecord);
                                proxyConfig.changeListener.setChanged(true);

                    	        break;
                    	    }
                    	    
                    	} else {
                    	    // Check validity of certificates
                    	    currRecord.certOKFlag = MyName.CERT_VALID;

                    	    proxyConfig.proxyConfigData.myNameList.add(currRecord);
                            tableModel.addRecord(currRecord);
                            proxyConfig.changeListener.setChanged(true);

                    	    break;	
                    	}

                	}
            	} else {
            	    
            	    break;
            	}
            } while (true);

            
            
            
            
            ProxyConfig.restoreOptionPaneBackground();

        } else  if (cmd.equals ("DEL_NAME")) {
            MyName currRecord = (MyName) tableModel.getRecord(myNameTable.getSelectedRow());
            delRecord(currRecord);
            
        } else if (cmd.equals ("EDIT_NAME")) {

           	MyName currRecord = (MyName) tableModel.getRecord(myNameTable.getSelectedRow());

           	editRecord (currRecord);

        }
        
    }
    
    public boolean delRecord (MyName currRecord) {
        if (currRecord != null) {
            int retVal = JOptionPane.showConfirmDialog(null, 
                    "Are you sure you want to delete the name " + currRecord + " ?", 
                    "Confirm Delete", JOptionPane.YES_NO_OPTION);
            if (retVal == JOptionPane.YES_OPTION) {
                tableModel.removeRecord(currRecord);
                
                proxyConfig.proxyConfigData.myNameList.remove(currRecord);
        		tableModel.fireTableDataChanged();

                proxyConfig.changeListener.setChanged(true);
                return true;
            }
            
        } else {
            ProxyConfig.beep();
        }
        return false;
    }
    
    public void editRecord (MyName currRecord) {
        ProxyConfig.changeOptionPaneBackground(Color.WHITE);

        if (currRecord != null) {
            MyNameEditPanel myNameEditPanel = new MyNameEditPanel(currRecord, proxyConfig);
            
            do {
                int retVal = JOptionPane.showConfirmDialog(null, 
                    	myNameEditPanel, "Modify Name", JOptionPane.OK_CANCEL_OPTION);
            	if (retVal == JOptionPane.OK_OPTION) {
                
                	if (myNameEditPanel.checkFields()) {
                
                    	myNameEditPanel.updateRecord(currRecord);
                		tableModel.fireTableDataChanged();
                    	proxyConfig.changeListener.setChanged(true);
                    	
                    	// check for certificates
                    	File tmpCertFile = new File (currRecord.certFileName);
                    	String certMsg = "";
                    	if (! tmpCertFile.exists()) {
                    	    certMsg += "Certificate file " + tmpCertFile.getPath() + " does not exist.\n";
                    	    currRecord.certOKFlag = MyName.CERT_NOT_FOUND;
                    	}
                    	
                    	File tmpPrivKeyFile = new File (currRecord.privKeyFileName);
                    	if (! tmpPrivKeyFile.exists()) {
                    	    certMsg += "Private key file " + tmpPrivKeyFile.getPath() + " does not exist.\n";
                    	    currRecord.certOKFlag = MyName.CERT_NOT_FOUND;
                    	}
                    	
                    	if ( ! certMsg.equals("")) {
                    	    certMsg += "\nSince the certificate for name " + currRecord.name + " has not been " 
                    	    			+ "correctly setup, \npeople will not be able to contact you on this name securely."
                    	    			+ "\nDo you want to specify the certificate again?";
                    	    
                    	    int certRetVal = JOptionPane.showConfirmDialog( null,
                                    certMsg,
                                    "Certificate Error",
                                    JOptionPane.YES_NO_OPTION
                        		);
                    	    if (certRetVal == JOptionPane.NO_OPTION) {
                    	        break;
                    	    }
                    	    
                    	} else {
                    	    // Check validity of certificates
                    	    currRecord.certOKFlag = MyName.CERT_VALID;
                    	    break;	
                    	}

                	}
            	} else {
            	    break;
            	}
            } while (true);
            
            if (currRecord.nameCertLB != null) {
                if (! currRecord.certOKFlag.equals (MyName.CERT_VALID)) {
                
                	currRecord.nameCertLB.setText ( "</font> <font color=\"red\" size=\"-1\"><i>(Certificate not specified)</i></font>");
                
            	} else {
            	    currRecord.nameCertLB.setText("");
            	}
            }
            
        } else {
            ProxyConfig.beep();
        }
        
        ProxyConfig.restoreOptionPaneBackground();

    }
    
    public String getNamesWithoutCerts() {
        
        String retStr = "";
        
        ListIterator itr = tableModel.getRecordList().listIterator();
        while (itr.hasNext()) {
            
            MyName currName = (MyName) itr.next();
            if (!currName.certOKFlag.equals (MyName.CERT_VALID)) {
                retStr += currName + "\n";
            }
        }
        
        if (retStr.equals ("")) {
            return null;
        } else {
            return retStr;
        }
    }
}
