/*
 * Created on Jan 18, 2005
 */
package proxyconfig.outboundconnections;

import java.util.*;
import proxyconfig.*;

/**
 * legacy URL ---> overlay network mapping record
 * @author danjo
 */
public class OutboundRecord {

    //TODO Support multiple Patterns
    public String pattern;

    public ArrayList hopList;
    
    /** This flag is true if this record is the default ocd id -> ocd mapping */
    public boolean ocdDefaultFlag;
    
    public int dstPort;
    
    public String securityProtocol;
    public static final String SECURITY_PROTOCOL_NONE = "none";
    public static final String SECURITY_PROTOCOL_CUSTOM_SSL = "customSSL";
    
    public String compressionAlgo;
    public static final String COMPRESSION_ALGO_NONE = "none";
    public static final String COMPRESSION_ALGO_ZLIB = "zlib";
    
    public int compressionLevel;
    
    public OutboundRecord () {
        hopList = new ArrayList();
        ocdDefaultFlag = false;
        dstPort = -1;
    }
    
    public String toString() {
        
        String retStr = pattern + " ::: " + getHopString() ;
        return retStr; 
    }
    
    public String getHopString () {
        String retStr = "" ;
        ListIterator itr = hopList.listIterator();
        while (itr.hasNext()) {
            HopInfo currHop = (HopInfo) itr.next();
            retStr += currHop;
            if (itr.hasNext()) {
                retStr += " --> ";
            }
        }
        return retStr;
    }
    
    boolean containsHop (String ocdId) {
        ListIterator itr = hopList.listIterator();
        while (itr.hasNext()) {
            
            HopInfo currHop = (HopInfo) itr.next();
            if ( currHop.ocdId.equals (ocdId)) {
                return true;
            }
        }
        return false;
    }
    
    void addHop (HopInfo hop) {
        hopList.add(hop);
    }
    
    public HopInfo getFirstHop() {
        if (hopList.size() > 0) {
            return (HopInfo) hopList.get(0);
        } else {
            return null;
        }
    }
}
